

#include "D:\Dev\MikroE\01-GPS\mcPro\gps_LIB\gps_LIB.h"

#include "built_in.h"




void do_rx_isr()  org 0x100 iv 0x000008
{
    char tmpChr;

    if (gps_rxBuf[0] != '$')                               // if 1st char not equal '$'
    {
      tmpChr =  UART1_Read();                              // load next char and test if '$'
      if (tmpChr == '$')                                   // if char ='$'
      {
        gps_rxBuf[0] = tmpChr;                             // put it in gps_rxBuf[0]
        gps_chrCount = 1;                                  // incr gps_chrCount
      }
    }
    else // if gps_rxBuf[0] = '$'                          // if rx char ='$'
    {
      gps_rxBuf[gps_chrCount] = UART1_Read();;             // read data and store it to gps_rxBuf string
      gps_chrCount++;                                      // incr chrCount

      if (gps_chrCount > 6)                                // if we have more then 6 chars
      {
        if  ( (gps_RxBuf[0] != frameID[0]) || (gps_RxBuf[1] != frameID[1]) || (gps_RxBuf[2] != frameID[2]) ||
              (gps_RxBuf[3] != frameID[3]) || (gps_RxBuf[4] != frameID[4]) || (gps_RxBuf[5] != frameID[5]))
        {
           for (gps_chrCount=0;gps_chrCount<GLL_maxRxBuf;gps_chrCount++)   // if any of chars don't match '$GPGLL'
           {
              gps_rxBuf[gps_chrCount] = 0x00;              // clear entire array of gps_rxBuf
           }
           gps_chrCount = 0;                               // reset chrCount
        }
      }
      if (gps_chrCount == (GLL_maxRxBuf-1))                    // we reached the end
      {
        gps_chrCount = 0;                                  // reset chrCount it to zero
        gps_ready = 1;  
                                                      // set 'Ready' flag for parsing GPS data
       }
    }
    if (gps_ready == 0)                                     // if not 'Ready' reset interrupt flag
      RCIF_bit = 0;                    // Set RCIF to 0     // enable interrupt

}


void gps_enable_int (void)
{
  RC1IE_bit = 1;                   // Enable USART Receiver interrupt
  GIE_bit   = 1;                   // Enable Global interrupt
  PEIE_bit  = 1;                   // Enable Peripheral interrupt
}

void gps_disable_int (void)
{
  RC1IE_bit = 0;                   // Enable USART Receiver interrupt
  //GIE_bit  = 0;                     // Enable Global interrupt
  PEIE_bit = 0;                    // Enable Peripheral interrupt
}

//-----------------------------//
// Convert gps time to string  //
//                             //
// Inp: ptr to gpsVAR          //
//    : string to store it in  //
//-----------------------------//
//
void gpsTimeToStr (gpsREC *tValue, char *tchr)
{
  tchr[0] = (tValue->hours/10)%10+48;       // convert tens digit hours
  tchr[1] = (tValue->hours%10)+48;          // convert ones digit minutes
  tchr[2] = ':';
  tchr[3] = (tValue->minutes/10)%10+48;     // convert tens digit minutes
  tchr[4] = (tValue->minutes%10)+48;        // convert ones digit minutes
  tchr[5] = ':';
  tchr[6] = (tValue->seconds/10)%10+48;     // convert tens digit minutes
  tchr[7] = (tValue->seconds%10)+48;        // convert ones digit minutes
}


//---------------------------------------------//
// extracts byte value of ascii digit at 'pos' //
// in array 'str'                              //
//                                             //
// valid digits = 'A'..'F' and '0'..'9'        //
// error return = 255                          //
//---------------------------------------------//
//
unsigned short gps_get_ascii_digit(char *str, unsigned short pos)
{
   char tmpChr;
   
   tmpChr = toupper(str[pos]);
   if ( (tmpChr >= 'A')  &&  (tmpChr <= 'F') )
       tmpChr = (tmpChr-55);
   else if ( (gps_rxBuf[GLL_crc_pos] >= '0')  &&  (gps_rxBuf[GLL_crc_pos] <= '9') )
      tmpChr = (tmpChr-48);
   else return 255;
   return tmpChr;
}//END=>gps_asciiDigits2Byte



//---------------------------------------------//
// extracts byte value of ascii digit at 'pos' //
// in array 'str'                              //
//                                             //
// valid digits = 'A'..'F' and '0'..'9'        //
// error return = 255                          //
//                                             //
// byteType = 0 -> convert to HEX              //
// byteTpe  = 1 -> convert to DECIMAL          //
//---------------------------------------------//
//
unsigned short gps_ascii2byte (char *str, unsigned short str_pos, unsigned short byteType)
{
  unsigned short tmpByte, tmpByte1;
  
   tmpByte = gps_get_ascii_digit (str, str_pos);             // 1st digit = str[pos]
   if (tmpByte == 255)
     return tmpByte;
     
   if (byteType == 0)                                        // convert to HEX
   {
     tmpByte = tmpByte << 4;                                 // shift to hi-nibble ( = *16)
     tmpByte1 = gps_get_ascii_digit (str, str_pos+1);        // 2nd digit = str[pos+1]
     if (tmpByte1 == 255)
       return tmpByte1;
     tmpByte = tmpByte + tmpByte1;
     return tmpByte;
   }
   else if (byteType == 1)
   {
     tmpByte = gps_get_ascii_digit(str, str_pos);
     if (tmpByte == 255)
       return tmpByte;
   
     if (tmpByte > 0)
     {
       tmpByte  = tmpByte * 10;
       tmpByte1 = gps_get_ascii_digit (str,str_pos+1);
       if (tmpByte1 == 255)
         return tmpByte1;
       tmpByte = tmpByte + tmpByte1;
     }
     else
       tmpByte = gps_get_ascii_digit (str,str_pos+1);
   }
   return tmpByte;

}//END=>gps_ascii2byte



//------------------------------------------------//
// check crc from 'startPos' to 'rndPos' in 'str' //
//                                                //
// crc TRUE  - return 1                           //
// crc FALSE - return 0                           //
//------------------------------------------------//
//
unsigned short gps_valid_crc (char *str, unsigned short startPos, unsigned short endPos)
{

   unsigned short idx, rx_crc, xor;

   xor = 0;
   idx     = startPos;            // xored checksum between '$' and '*' $123456789*
   while (idx < endPos)
   {
     xor ^= str[idx];
     idx++;
   }
   // extract crc from 'rxBuf'and compare with computed value
   //
   rx_crc = gps_ascii2byte (str, GLL_crc_pos, 0);
   if (rx_crc == 255)
     return 0;
   if (rx_crc == xor)
     return 1;
   else
     return 0;
}//END=>gps_valid_crc

//----------------------------------//
// converts UTC to curent time zone //
//----------------------------------//
//
void gpsTime_to_time_zone (gpsREC *gpsTime)
{
   signed short int tmp1, tmp2;
   
   if ((gpsTime->timeZone > 14) || (gpsTime->timeZone < -11))
     return;

   if (gpsTime->timeZone != 0)
   {
     tmp1 = gpsTime->hours;
     tmp2 = tmp1 + gpsTime->timeZone;
     if (tmp2 < 0)
       tmp2 = tmp2+24;
     else if (tmp2 >= 24)
       tmp2 = tmp2-24;
   }
   else
     tmp2 = 0;

   gpsTime->hours = tmp2;
}//END=>gpsTime_to_time_zone


//------------------------------------------------//
// 'gps_get_time' extracts time date from 'rxBuf' //
//  and puts it to 'gpsVAR.hours'                 //
//                 'gpsVAR.minutes'               //
//                 'gpsVAR.seconds'               //
//------------------------------------------------//
//
void gps_get_time (char *strBuf, gpsREC *gpsData)
{

   unsigned int decValue;

   decValue = ((strBuf[GLL_hour_pos]-48) * 10);
   decValue = decValue+(strBuf[GLL_hour_pos+1]-48);
   gpsData->hours = Lo(decValue);

   decValue = ((strBuf[GLL_minute_pos]-48) * 10);
   decValue = decValue+(strBuf[GLL_minute_pos+1]-48);
   gpsData->minutes = Lo(decValue);
   
   decValue = ((strBuf[GLL_second_pos]-48) * 10);
   decValue = decValue+(strBuf[GLL_second_pos+1]-48);
   gpsData->seconds = Lo(decValue);

}//END=>gps_get_time




//---------------------------------------------------------//
// 'gps_get_position extracts latitude and longitude       //
//  from 'rxBuf' and transates it to decimal coordinates   //
//  and puts it to 'gpsVAR.latitude'                       //
//                 'gpsVAR.longitude'                      //
//                 'gpsVAR.NS_indicator+gpsVAR.EW_indicator//
//                  are updated accordingly                //
//---------------------------------------------------------//
//
void gps_get_position (char *buf, gpsREC *gpsData)
{
  double        gpsDeg;
  double        gpsMin;
  double        decMin;
  unsigned long intDec;
   //
   // extract and calc 'latitude'
   //
   gpsDeg = (double) gps_ascii2byte (buf, GLL_lat_pos,   1);                                   // convert deg of latitude (1st 2 chars)
   gpsMin = (double) gps_ascii2byte (buf, GLL_lat_pos+2, 1);                                   // convert min of latitude
   intDec = (buf[GLL_lat_pos+5]-48);intDec = (intDec*10000);
   intDec = intDec + ((buf[GLL_lat_pos+6]-48)*1000);
   intDec = intDec + ((buf[GLL_lat_pos+7]-48)*100);
   intDec = intDec + ((buf[GLL_lat_pos+8]-48)*10) +  (buf[GLL_lat_pos+9]-48);
   decMin = ( ((double)intDec) * 0.00001);
   gpsMin = ((gpsMin + decMin) / 60.0);
   gpsData->latitude = gpsDeg+gpsMin;
   //
   // extract and calc 'longitude'
   //
   gpsDeg = ((buf[GLL_long_pos]-48)*100) + ((buf[GLL_long_pos+1]-48)*10)+((buf[GLL_long_pos+2]-48));  // convert deg of longitude (1st 3 chars)
   gpsMin = (double) gps_ascii2byte (buf, GLL_long_pos+3, 1);                                 // convert min of longitude
   intDec = (buf[GLL_long_pos+6]-48); intDec = (intDec*10000);
   intDec = intDec+((buf[GLL_long_pos+ 7]-48)*1000);
   intDec = intDec+((buf[GLL_long_pos+ 8]-48)*100);
   intDec = intDec+((buf[GLL_long_pos+ 9]-48)*10);
   intDec = intDec+((buf[GLL_long_pos+10]-48));
   decMin = ( ((double)intDec) * 0.00001);
   gpsMin = ((gpsMin + decMin) / 60.0);
   gpsData->longitude = gpsDeg+gpsMin;

}//END=>gps_get_position


//--------------------------//
// 'gps_reeset_vars' resets //
//  global vars to zero.    //
//--------------------------//
//
void gps_reset_vars (void)
{
  memset(gps_rxBuf,0x00,sizeof(gps_rxBuf));            // clear 'gps_rxBuf'
  gps_ready    = 0;                                    // clear 'gps_ready' flag
  gps_chrCount = 0;                                    // clear chr counter used by ISR

}//END=>gps_reset_vars


//-----------------------------------//
// 'gps_initialise' initialises all  //
//  relevant variables and coms port //
//-----------------------------------//
//
void gps_initialise (signed short int _timezone)
{
  gps_rxPtr= &gps_rxBuf;                                   // init ptr to gps_rxBuf
  gpsPtr   = &gpsVAR;                                      // init ptr to gpsVAR
  memset    (&gpsVAR,0x00,sizeof(gpsVAR));                 // clear gpsVAR
  gps_reset_vars ();
  ANSELC.B7 = 0;                                           // set RC7 as digital I/O
  ANSELC.B6 = 0;                                           // set RC6 as digital I/O
  UART1_Init (9600);                                       // init uart to 9600 bps
  gpsPTR->timeZone = _timezone;                            // set timezone
}//END=>gps_initialise


unsigned short gps_get_NMEA_frame (char *gps_frame_id)
{
  frameID = gps_frame_id;                                  // specify what message to look for
  gps_enable_int();                                        // enable interrupts (coms + global)

  while (1)
  {

    while ((gps_ready == 0) && (gps_delay_ticks < max_gps_delay_ticks))
    {
      Delay_us (500);
      gps_delay_ticks++;
    }
    if (gps_delay_ticks >= max_gps_delay_ticks)            // if >= max_gps_delay_ticks then coms receive error
      return 0;
    //
    // we get here if data in gps_rxBuf array is ready
    //
    gps_disable_int();                                     // disable interrupt (coms)

    if ( gps_valid_crc (gps_rxPtr,GLL_crc_start,GLL_crc_end) == 1) // check if crc is ok and if ok
    {
      gpsVAR.NS_indicator = gps_rxBuf[GLL_NS_pos];         // update (N)orth/(S)outh indicator
      gpsVAR.EW_indicator = gps_rxBuf[GLL_EW_pos];         // update (E)ast/(W)est   indicator
      gps_get_position     (gps_rxPtr, gpsPtr);            // extract and load 'latitude' and 'longitude'
      gps_get_time         (gps_rxPtr, gpsPtr);            // extract and load time data
      gpsTime_to_time_zone (gpsPTR);                       // xlat utc to local time
      gps_reset_vars ();                                   // reset gps_flag, gps_chrCount and gps_rxBuf

      return 1;
    }
    else
    {
      gps_reset_vars ();                                   // reset gps_flag, gps_chrCount and gps_rxBuf
      return 0;
    }
   }
}//END=>

/*
  example test


#include "D:\Dev\MikroE\01-GPS\mcPro\gps_LIB\gps_LIB.c"


unsigned int err, good, k;
unsigned short eInfo;

void main()

{
  gps_initialise();

  k    = 1;   // only used for breakpoint setting
  err  = 0;
  good = 0;
  while (k < 20)
  {
    eInfo = gps_get_NMEA_frame ("$GPGLL");   // add 'gpsVAR' to debug var display to watch changes
    if (eInfo == 1)
      good++;
    else
      err++;
    delay_ms(300);
    k++;
  }//while
  k++;

}
 */